import commands, { Command, Extras } from ".";
import { filterAsync } from "../util";

const cmdHelp: Command = {
  names: ["help", "cmds"],
  desc: "list out commands you have access to",
  splitArgs: false,

  checkPerm: async () => true,

  async handler(ex: Extras) {
    const availCmds = await filterAsync(
      commands,
      async (cmd) => await cmd.checkPerm(ex.msg)
    );

    let text = `// List of commands (${availCmds.length} count)\n`;

    for (let cmd of availCmds) {
      text += `${cmd.names[0]} `;
      if (cmd.names.length > 1) {
        text += `(aka: ${cmd.names.slice(1).join(", ")}) `;
      }
      text += `- ${cmd.desc}\n`;
    }

    text = "```\n" + text + "\n```";
    await ex.reply(text);
  },
};

export default cmdHelp;
