import { Message } from "oceanic.js";
import cmdHelp from "./help";
import cmdHi from "./hi";
import cmdPlay from "./play";
import cmdEcho from "./echo";

export class Extras {
  constructor(readonly msg: Message) {
    this.msg = msg;
  }

  reply = async (text: string) => {
    await this.msg.channel?.createMessage({
      content: text,
      allowedMentions: {
        repliedUser: false,
      },
      messageReference: {
        messageID: this.msg.id,
      },
    });
  };

  say = async (text: string) => {
    await this.msg.channel?.createMessage({
      content: text,
    });
  };
}

export type Command = {
  names: string[];
  desc: string;
  splitArgs: boolean;
  checkPerm(msg: Message): Promise<boolean | undefined>;
  handler(ex: Extras, ...args: string[]): Promise<void>;
};

const commands: Command[] = [cmdHelp, cmdHi, cmdPlay, cmdEcho];

export default commands;
